#include "GameMain.h"
#include "types.h"
#include "stdlib.h"
#include "pad.h"
#include "pg.h"
#include "performance.h"

enum {
	STATUS_INIT = 0,
	STATUS_WORK,
};

long g_status = STATUS_INIT;

#define MAX_TARGET_NUM 2
#define OBJECT_LIVE		1
#define OBJECT_DIE		0
#define MAP_WIDTH		(SCREEN_WIDTH+2)
#define MAP_HEIGHT		(SCREEN_HEIGHT+2)
#define LIVE_COLOR		RGB(255,64,64)
#define DIE_COLOR		RGB(64, 64, 255)


BYTE abtObj[MAX_TARGET_NUM][MAP_HEIGHT][MAP_WIDTH];
WORD awScreen[SCREEN_HEIGHT][SCREEN_WIDTH];

long g_target_num = 0;


// Ƃ
void Game_Init(void)
{
	ctrl_data_t stCtrl;
	CtrlRead(&stCtrl, 1);
	srand(stCtrl.frame);

	// e평
	g_target_num = 0;
	memset(&abtObj, 0x00, sizeof(abtObj));
	memset(&awScreen, 0x00, sizeof(awScreen));
	int x, y;
	for (y = 0; y < SCREEN_HEIGHT; y++) {
		for (x = 0; x < SCREEN_WIDTH; x++) {
			abtObj[g_target_num][y+1][x+1] = (rand() % 2);
		}
	}

	g_status = STATUS_WORK;
}

// Ԃ̍XV
void UpdateObject(long lOld, long lNew)
{
	LPWORD pwScreen = (LPWORD)awScreen;
	int x, y;
	const long tblResultObject[2][9]={
		OBJECT_DIE, OBJECT_DIE, OBJECT_DIE, OBJECT_LIVE, OBJECT_DIE, OBJECT_DIE, OBJECT_DIE, OBJECT_DIE, OBJECT_DIE,
		OBJECT_DIE, OBJECT_DIE, OBJECT_LIVE, OBJECT_LIVE, OBJECT_DIE, OBJECT_DIE, OBJECT_DIE, OBJECT_DIE, OBJECT_DIE,
	};
	const long tblResultObjectColor[2][9]={
		DIE_COLOR, DIE_COLOR, DIE_COLOR, LIVE_COLOR, DIE_COLOR, DIE_COLOR, DIE_COLOR, DIE_COLOR, DIE_COLOR,
		DIE_COLOR, DIE_COLOR, LIVE_COLOR, LIVE_COLOR, DIE_COLOR, DIE_COLOR, DIE_COLOR, DIE_COLOR, DIE_COLOR,
	};
	for (y = 0; y < SCREEN_HEIGHT; y++) {
		for (x = 0; x < SCREEN_WIDTH; x++) {
			int nSum = abtObj[lOld][y  ][x] + abtObj[lOld][y  ][x+1] + abtObj[lOld][y  ][x+2] +
					   abtObj[lOld][y+1][x] +                          abtObj[lOld][y+1][x+2] +
					   abtObj[lOld][y+2][x] + abtObj[lOld][y+2][x+1] + abtObj[lOld][y+2][x+2];
			int nOld = abtObj[lOld][y+1][x+1];
			abtObj[lNew][y+1][x+1] = tblResultObject[nOld][nSum];
			*pwScreen = tblResultObjectColor[nOld][nSum];
			pwScreen++;
		}
	}
}

// C
void Game_Work(void)
{
	static int nWait = 10;
	static int nWaitTmp = 0;

	if (nWait > nWaitTmp) {
		nWaitTmp++;
		pgBitBlt(0,0,SCREEN_WIDTH,SCREEN_HEIGHT, (LPWORD)awScreen);
		pgScreenFlipV();
		return;
	}
	nWaitTmp = 0;

	ctrl_data_t stCtrl;
/*
	long lStart, lWorkTime;
	lStart = Performance_Set(0);
*/
	// L[
	CtrlRead(&stCtrl, 1);
	if (stCtrl.buttons & CTRL_SELECT) {
		Game_Init();
	}
	if (stCtrl.buttons & CTRL_UP) {
		if (nWait > 0) nWait--;
	}
	else if (stCtrl.buttons & CTRL_DOWN) {
		if (nWait < 20) nWait++;
	}
	if (stCtrl.buttons & CTRL_CIRCLE) {
		// ꂽ1`100Őa
		int cbI = rand() %100 + 1;
		while (cbI) {
			abtObj[g_target_num][rand() % MAP_HEIGHT][rand() % MAP_WIDTH] = OBJECT_LIVE;
			cbI--;
		}
	}

	// H
	long lOldTarget = g_target_num;
	g_target_num = (g_target_num + 1) % MAX_TARGET_NUM;
	UpdateObject(lOldTarget, g_target_num);

	pgBitBlt(0,0,SCREEN_WIDTH,SCREEN_HEIGHT, (LPWORD)awScreen);

/*
	// ptH[}X̃`FbN

	lWorkTime = Performance_Set(1) - lStart;

	char szMsg[256], szTemp[256];
	strcpy(szMsg, "WorkTime=");
	dwtoa(lWorkTime, szTemp);
	strcat(szMsg, szTemp);
	strcat(szMsg, "microsec");
	mh_print(0,0,szMsg,0xFFFF);
*/
	pgScreenFlipV();
}

void GameMain(void)
{
	switch (g_status) {
	case STATUS_INIT: Game_Init(); break;
	case STATUS_WORK: Game_Work(); break;
	}
}
